Program frogger;
global
	puntos[1];
	linea[9];
	grafcoche;
	grafcamion;
	grafrana;
	grafrana2;
	sonidos[1];
begin
	full_screen=1;
	from x=0 to 9;
		linea[x]=16+32*x;
	end
	set_mode(320,240,8);
	x=160; y=120;
	graph=load_png(".\fpg\panreyes.png");
	if(!key(_enter))
		from alpha=0 to 255 step 5; frame; end
		frame(10000);
		from alpha=255 to 0 step -5; frame; end
		put_screen(0,load_png(".\fpg\menu1.png"));
		while(!key(_enter)) frame; end
	end
	put_screen(0,load_png(".\fpg\fondo.png"));
	grafcoche=load_png(".\fpg\coche.png");
	grafcamion=load_png(".\fpg\camion.png");
	grafrana=load_png(".\fpg\rana.png");
	grafrana2=load_png(".\fpg\rana1.png");
	write_int(0,0,0,0,&fps);
	nuevonivel();
end

process lineacoches(numlinea,tipo,frecuencia,velocidad);
private
	ancho;
	i;
begin
	switch(tipo)
		case 0:
			graph=grafcoche;
		end
		case 1:
			graph=grafcamion;
		end
	end
	ancho=graphic_info(file,graph,g_width);
	graph=0;
	coche(numlinea,tipo,velocidad);
	loop
		if(velocidad>0) 
			for(i=0; i<ancho*frecuencia; i+=velocidad) frame; end
		else
			for(i=ancho*frecuencia; i>0; i+=velocidad) frame; end
		end
		coche(numlinea,tipo,velocidad);
		frame;
	end
end

process coche(numlinea,tipo,velocidad);
private
	ancho;
begin
	while(velocidad==0) velocidad=rand(-7,7); end
	if(numlinea<4) angle=-90000; else angle=90000; end
	x=linea[numlinea];
	z=-1;
	switch(tipo)
		case 0:
			graph=grafcoche;
		end
		case 1:
			graph=grafcamion;
		end
	end
	ancho=graphic_info(file,graph,g_width);
	if(velocidad>0) y=-ancho/2; end
	if(velocidad<0) y=240+ancho/2; end
	while(y=>-ancho/2 and y<=240+ancho/2)
		y+=velocidad;
		frame;
	end
end

// centro y lneas
// 0: 30 - marcador
// 1: 90 - fin de la calle
// 2: 150
// 3: 210
// 4: 270
// 5: 330 - mitad de la calle
// 6: 390
// 7: 450
// 8: 510
// 9: 570 - principio de la calle

process rana();
private
	sulinea;
	pulsando;
begin
	angle=-90000;
	y=100;
	sulinea=0;
	graph=grafrana;
	loop
		if(key(_backspace) and key(_tab)) exit(); end
		if(pulsando==1 and !key(_enter)) pulsando=0; end
		if(key(_enter) and pulsando==0) sulinea++; pulsando=1; end
		if(collision(type coche)) sulinea=0; end
		if(sulinea==9) puntos[0]++; nuevonivel(); return; end
		x=linea[sulinea];
		frame;
	end
end

process rana2();
private
	sulinea;
	pulsando;
begin
	angle=90000;
	y=140;
	sulinea=9;
	graph=grafrana2;
	loop
		if(key(_esc)) exit(); end
		if(pulsando==1 and !key(_space)) pulsando=0; end
		if(key(_space) and pulsando==0) sulinea--; pulsando=1; end
		if(collision(type coche)) sulinea=9; end
		if(sulinea==0) puntos[1]++; nuevonivel(); return; end
		x=linea[sulinea];
		frame;
	end
end

process puntoseador(asdrubol);
begin
	switch(asdrubol)
		case 1:
			graph=write_in_map(0,"Puntos 1:",3);
			x=144;
			y=15;
			angle=-90000;
			puntoseador(2);
		end
		case 2:
			graph=write_in_map(0,"Puntos 2:",6);
			x=176;
			y=225;
			angle=90000;
			puntoseador(3);
		end
		case 3:
			graph=write_in_map(0,puntos[0],3);
			x=134;
			y=15;
			angle=-90000;
			puntoseador(4);
		end
		case 4:
			graph=write_in_map(0,puntos[1],6);
			x=186;
			y=225;
			angle=90000;
		end
	end
	loop
		frame;
	end
end

process nuevonivel();
begin
	let_me_alone();
	puntoseador(1);
	lineacoches(1,rand(0,1),rand(3,6),rand(-7,7)); //parametros: numerolinea, tipodevehiculo, frecuencia, velocidad 
	lineacoches(2,rand(0,1),rand(3,6),rand(-7,7)); //parametros: numerolinea, tipodevehiculo, frecuencia, velocidad 
	lineacoches(3,rand(0,1),rand(3,6),rand(-7,7)); //parametros: numerolinea, tipodevehiculo, frecuencia, velocidad 
	lineacoches(6,rand(0,1),rand(3,6),rand(-7,7)); //parametros: numerolinea, tipodevehiculo, frecuencia, velocidad 
	lineacoches(7,rand(0,1),rand(3,6),rand(-7,7)); //parametros: numerolinea, tipodevehiculo, frecuencia, velocidad 
	lineacoches(8,rand(0,1),rand(3,6),rand(-7,7)); //parametros: numerolinea, tipodevehiculo, frecuencia, velocidad 
	set_fps(0,9);
	frame(50000);
	set_fps(30,0);
	rana();
	rana2();
end